#------------------------------------------------------------
# Makefile    Default installation builds sequential version

ifeq ($(WHICH_RUNTIME),)
WHICH_RUNTIME =	seq
endif

ifeq ($(WHICH_RUNTIME),seq)
RUNTIME_COMP_FLAGS =	-DSTATS
endif

ifeq ($(WHICH_RUNTIME),dash)
RUN_COMP_FLAGS =	-lmpc
endif
ifeq ($(WHICH_RUNTIME),pthreads)
RUN_COMP_FLAGS =	-lm -lpmon
endif
ifeq ($(WHICH_RUNTIME),sgi)
RUN_COMP_FLAGS =	-lmpc
endif
ifeq ($(WHICH_RUNTIME),mint)
RUN_COMP_FLAGS =	-lmpc
endif

TARGET =	runtime_$(WHICH_RUNTIME)
PACKAGE_NAME =	runtime
SUPER_PACKAGES_PATH = baseparsuif
HEADERS =	runtime.h runtime_names.h fastsync.h
EXPORTS =	runtime.h runtime_names.h
TMP_SRCS =	runtime_$(WHICH_RUNTIME).c fastsync_$(WHICH_RUNTIME).c
OTHERSRCS =	runtime.c runtime_test.c c.m4.dash c.m4.pthreads c.m4.sgi \
		c.m4.seq c.m4.mint c.m4.solaris c.m4.common \
		Makefile.standalone.in feedback.c \
		fastsync.c fastsync_asm_sgi.s fastsync_asm_alpha.s
TMP_OTHERSRCS =	runtime_dash.c runtime_pthreads.c runtime_sgi.c runtime_seq.c \
		runtime_dash.o runtime_pthreads.o runtime_sgi.o runtime_seq.o \
		fastsync_dash.c fastsync_pthreads.c fastsync_sgi.c \
		fastsync_seq.c \
		fastsync_dash.o fastsync_pthreads.o fastsync_sgi.o \
		fastsync_seq.o \
		fastsync_asm_alpha.o fastsync_asm_sgi.o Makefile.standalone

ifeq ($(WHICH_RUNTIME),seq)
EXTRA_CFLAGS = $(RUNTIME_COMP_FLAGS)
else
ifeq (sgi_c++,$(COMPILER_NAME))
EXTRA_CFLAGS = -g3 -O4 $(RUNTIME_COMP_FLAGS)
else 
EXTRA_CFLAGS = -O4 $(RUNTIME_COMP_FLAGS)
endif
endif

ifeq ($(WHICH_RUNTIME),sgi)
EXTRA_OBJS = fastsync_asm_$(WHICH_RUNTIME).o
ASFLAGS = -mips2
else
EXTRA_OBS =
ASFLAGS =
endif
M4FLAGS =

OBJS =		runtime_$(WHICH_RUNTIME).o fastsync_$(WHICH_RUNTIME).o \
		$(EXTRA_OBJS)

all:		lib
install-bin:	install-lib


runtime_$(WHICH_RUNTIME).c : runtime.c c.m4.$(WHICH_RUNTIME) c.m4.common
	@rm -f runtime_$(WHICH_RUNTIME).c
	m4 $(M4FLAGS) c.m4.$(WHICH_RUNTIME) runtime.c > \
		runtime_$(WHICH_RUNTIME).c

fastsync_$(WHICH_RUNTIME).c : fastsync.c c.m4.$(WHICH_RUNTIME) c.m4.common
	@rm -f fastsync_$(WHICH_RUNTIME).c
	m4 $(M4FLAGS) c.m4.$(WHICH_RUNTIME) fastsync.c > \
		fastsync_$(WHICH_RUNTIME).c

run_$(WHICH_RUNTIME) : runtime_$(WHICH_RUNTIME).o runtime_test.o \
			fastsync_$(WHICH_RUNTIME).o
	$(CC) -o run_$(WHICH_RUNTIME) $(OBJS) runtime_test.o $(RUN_COMP_FLAGS)

runtime_$(WHICH_RUNTIME)_all_stats.o : runtime_$(WHICH_RUNTIME).c runtime.h
	$(CC) -c $(CFLAGS) -DSTATS -DALL_STATS runtime_$(WHICH_RUNTIME).c
	mv runtime_$(WHICH_RUNTIME).o runtime_$(WHICH_RUNTIME)_all_stats.o

libruntime_$(WHICH_RUNTIME)_all_stats.a : \
		runtime_$(WHICH_RUNTIME)_all_stats.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)
	ar ruvs libruntime_$(WHICH_RUNTIME)_all_stats.a \
		runtime_$(WHICH_RUNTIME)_all_stats.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)

runtime_$(WHICH_RUNTIME)_feedback.o : runtime_$(WHICH_RUNTIME).c runtime.h
	$(CC) -c $(CFLAGS) -DFEEDBACK runtime_$(WHICH_RUNTIME).c
	mv runtime_$(WHICH_RUNTIME).o runtime_$(WHICH_RUNTIME)_feedback.o

libruntime_$(WHICH_RUNTIME)_feedback.a : runtime_$(WHICH_RUNTIME)_feedback.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)
	ar ruvs libruntime_$(WHICH_RUNTIME)_feedback.a \
		runtime_$(WHICH_RUNTIME)_feedback.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)

runtime_$(WHICH_RUNTIME)_stats.o : runtime_$(WHICH_RUNTIME).c runtime.h
	$(CC) -c $(CFLAGS) -DSTATS runtime_$(WHICH_RUNTIME).c
	mv runtime_$(WHICH_RUNTIME).o runtime_$(WHICH_RUNTIME)_stats.o

libruntime_$(WHICH_RUNTIME)_stats.a : runtime_$(WHICH_RUNTIME)_stats.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)
	ar ruvs libruntime_$(WHICH_RUNTIME)_stats.a \
		runtime_$(WHICH_RUNTIME)_stats.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)

runtime_$(WHICH_RUNTIME)_trace.o : runtime_$(WHICH_RUNTIME).c runtime.h
	$(CC) -c $(CFLAGS) -DGEN_TRACE runtime_$(WHICH_RUNTIME).c
	mv runtime_$(WHICH_RUNTIME).o runtime_$(WHICH_RUNTIME)_trace.o

libruntime_$(WHICH_RUNTIME)_trace.a : runtime_$(WHICH_RUNTIME)_trace.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)
	ar ruvs libruntime_$(WHICH_RUNTIME)_trace.a \
		runtime_$(WHICH_RUNTIME)_trace.o \
		fastsync_$(WHICH_RUNTIME).o $(EXTRAOBJS)

Makefile.standalone: Makefile.standalone.in
	@rm -f Makefile.standalone
	m4 $(M4FLAGS) Makefile.standalone.in > Makefile.standalone

include $(SUIFHOME)/Makefile.std
